package com.gxwebsoft.cms.controller;

import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.cms.service.MpPagesService;
import com.gxwebsoft.cms.entity.MpPages;
import com.gxwebsoft.cms.param.MpPagesParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 小程序页面控制器
 *
 * @author 科技小王子
 * @since 2024-07-20 19:49:55
 */
@Api(tags = "小程序页面")
@RestController
@RequestMapping("/api/cms/mp-pages")
public class MpPagesController extends BaseController {
    @Resource
    private MpPagesService mpPagesService;

    @ApiOperation("分页查询小程序页面")
    @GetMapping("/page")
    public ApiResult<PageResult<MpPages>> page(MpPagesParam param) {
        // 使用关联查询
        return success(mpPagesService.pageRel(param));
    }

    @ApiOperation("查询全部小程序页面")
    @GetMapping()
    public ApiResult<List<MpPages>> list(MpPagesParam param) {
        // 使用关联查询
        return success(mpPagesService.listRel(param));
    }

    @PreAuthorize("hasAuthority('cms:mpPages:list')")
    @ApiOperation("根据id查询小程序页面")
    @GetMapping("/{id}")
    public ApiResult<MpPages> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(mpPagesService.getByIdRel(id));
    }

    @ApiOperation("添加小程序页面")
    @PostMapping()
    public ApiResult<?> save(@RequestBody MpPages mpPages) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         mpPages.setUserId(loginUser.getUserId());
        }
        if (mpPagesService.save(mpPages)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改小程序页面")
    @PutMapping()
    public ApiResult<?> update(@RequestBody MpPages mpPages) {
        if (mpPagesService.updateById(mpPages)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除小程序页面")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (mpPagesService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加小程序页面")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<MpPages> list) {
        if (mpPagesService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改小程序页面")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<MpPages> batchParam) {
        if (batchParam.update(mpPagesService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除小程序页面")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (mpPagesService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
